"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var event_flux_1 = require("event-flux");
var constants_1 = require("./constants");
var MultiWinSaver_1 = __importDefault(require("./MultiWinSaver"));
var objectDifference_1 = __importDefault(require("./utils/objectDifference"));
var objUtils_1 = require("./utils/objUtils");
var filterApply_1 = __importDefault(require("./utils/filterApply"));
var MainClient_1 = __importDefault(require("./MainClient"));
var filterDifference_1 = __importDefault(require("./utils/filterDifference"));
var json_immutable_bn_1 = require("json-immutable-bn");
function getStoreType(storeDeclarer) {
    if (event_flux_1.StoreDeclarer.isStore(storeDeclarer)) {
        return "Item";
    }
    else if (event_flux_1.StoreListDeclarer.isStoreList(storeDeclarer)) {
        return "List";
    }
    else if (event_flux_1.StoreMapDeclarer.isStoreMap(storeDeclarer)) {
        return "Map";
    }
    else {
        throw new Error("Not valid store declarer");
    }
}
function genOutStoreDeclarers(appStore) {
    var declarers = [];
    for (var key in appStore._storeRegisterMap) {
        var storeDeclarer = appStore._storeRegisterMap[key];
        var options = storeDeclarer.options;
        var storeKey = options.storeKey, stateKey = options.stateKey;
        var _a = storeDeclarer.Store.prototype, _evs = _a._evs, _invokers = _a._invokers;
        var storeType = getStoreType(storeDeclarer);
        var outDeclarer = {
            storeKey: storeKey,
            stateKey: stateKey,
            storeType: storeType,
            depStoreNames: storeDeclarer.depStoreNames,
            _evs: _evs,
            _invokers: _invokers,
        };
        if (storeType === "List") {
            outDeclarer.size = options.size;
            var _b = (options.StoreList || event_flux_1.StoreList).prototype, _mapEvs = _b._evs, _mapInvokers = _b._invokers;
            outDeclarer._mapEvs = _mapEvs;
            outDeclarer._mapInvokers = _mapInvokers;
        }
        else if (storeType === "Map") {
            outDeclarer.keys = options.keys;
            var _c = (options.StoreMap || event_flux_1.StoreMap).prototype, _mapEvs = _c._evs, _mapInvokers = _c._invokers;
            outDeclarer._mapEvs = _mapEvs;
            outDeclarer._mapInvokers = _mapInvokers;
        }
        declarers.push(outDeclarer);
    }
    return JSON.stringify(declarers);
}
var MainAppStore = /** @class */ (function (_super) {
    __extends(MainAppStore, _super);
    function MainAppStore(storeDeclarers, options) {
        var _this = _super.call(this, storeDeclarers, {}) || this;
        _this.multiWinSaver = new MultiWinSaver_1.default();
        _this.winFilters = {};
        _this.outStoreDeclarers = "";
        _this.winHoldStores = {};
        _this.storeMapModes = {};
        _this.winObserves = {};
        _this.serializer = (options && options.serializer) || json_immutable_bn_1.serialize;
        _this.deserializer = (options && options.deserializer) || json_immutable_bn_1.deserialize;
        var ClientClass = (options && options.MainClient) || MainClient_1.default;
        _this.mainClient = new ClientClass(_this.multiWinSaver, _this);
        return _this;
    }
    MainAppStore.prototype.init = function () {
        var _this = this;
        _super.prototype.init.call(this);
        // In main process, AppStore will not preload static stores, we need load them there
        this.preloadStaticStores();
        this.outStoreDeclarers = genOutStoreDeclarers(this);
        this.multiWinSaver.winInfos.forEach(function (winInfo) {
            _this.winFilters[winInfo.winId] = {};
            _this.winHoldStores[winInfo.winId] = new Set();
            _this.winObserves[winInfo.winId] = {};
        });
        this.multiWinSaver.onDidAddWin(function (winId) {
            _this.winFilters[winId] = {};
            _this.winHoldStores[winId] = new Set();
            _this.winObserves[winId] = {};
        });
        this.multiWinSaver.onDidDeleteWin(function (winId) {
            var e_1, _a;
            var winStoreKeys = _this.winHoldStores[winId];
            try {
                for (var winStoreKeys_1 = __values(winStoreKeys), winStoreKeys_1_1 = winStoreKeys_1.next(); !winStoreKeys_1_1.done; winStoreKeys_1_1 = winStoreKeys_1.next()) {
                    var storeKey = winStoreKeys_1_1.value;
                    var mapStoreIndex = storeKey.split("@");
                    if (mapStoreIndex.length === 1) {
                        _this.releaseStore(storeKey, winId);
                    }
                    // else {
                    //   let store = this.stores[this._getStoreKey(mapStoreIndex[0], winId)] as StoreMap<any>;
                    //   store.releaseStore(mapStoreIndex[1]);
                    // }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (winStoreKeys_1_1 && !winStoreKeys_1_1.done && (_a = winStoreKeys_1.return)) _a.call(winStoreKeys_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            delete _this.winHoldStores[winId];
            delete _this.winFilters[winId];
            delete _this.winObserves[winId];
        });
        if (process.env.NODE_ENV !== "production") {
            this._checkStoreRegistry();
        }
        return this;
    };
    /**
     * The window-spec stores can dependen on the window-spec stores and plain stores
     * The plain stores can only dependen on the plain stores, not window-spec stores.
     */
    MainAppStore.prototype._checkStoreRegistry = function () {
        var storeRegistry = this._storeRegisterMap;
        for (var storeKey in storeRegistry) {
            var _a = storeRegistry[storeKey], options = _a.options, depStoreNames = _a.depStoreNames;
            if (!options.isPerWin && depStoreNames && depStoreNames.length > 0) {
                var isAllPlainStores = depStoreNames.every(function (name) { return !storeRegistry[name].options.isPerWin; });
                if (!isAllPlainStores) {
                    console.error("The plain store " + storeKey + " can not dependent on the window-spec stores");
                }
            }
        }
    };
    MainAppStore.prototype.requestStore = function (storeKey, winId) {
        return _super.prototype.requestStore.call(this, storeKey, winId);
    };
    MainAppStore.prototype.releaseStore = function (storeKey, winId) {
        return _super.prototype.releaseStore.call(this, storeKey, winId);
    };
    MainAppStore.prototype._getStoreKey = function (storeKey, winId) {
        var isPerWin = this._storeRegisterMap[storeKey].options.isPerWin;
        if (isPerWin) {
            if (!winId) {
                throw new Error("The winId parameter is necessary when creating isPerWin store ");
            }
            storeKey = storeKey + "@" + winId;
        }
        return storeKey;
    };
    MainAppStore.prototype._parseStoreKey = function (finalStoreKey) {
        var _a = __read(finalStoreKey.split("@"), 2), storeKey = _a[0], winId = _a[1];
        return [storeKey, winId];
    };
    MainAppStore.prototype._getStateKey = function (storeKey, stateKey, winId) {
        var isPerWin = this._storeRegisterMap[storeKey].options.isPerWin;
        if (isPerWin) {
            if (!winId) {
                throw new Error("The winId parameter is necessary when creating isPerWin store ");
            }
            stateKey = stateKey + "@" + winId;
        }
        return stateKey;
    };
    MainAppStore.prototype._createStore = function (storeKey, store, winId) {
        var isPerWin = this._storeRegisterMap[storeKey].options.isPerWin;
        if (isPerWin) {
            if (!winId) {
                throw new Error("The winId parameter is necessary when creating isPerWin store ");
            }
            storeKey = storeKey + "@" + winId;
            store.winId = winId;
        }
        this.stores[storeKey] = store;
    };
    MainAppStore.prototype._deleteStore = function (storeKey, winId) {
        var isPerWin = this._storeRegisterMap[storeKey].options.isPerWin;
        if (isPerWin) {
            if (!winId) {
                throw new Error("The winId parameter is necessary when delete isPerWin store ");
            }
            storeKey = storeKey + "@" + winId;
        }
        delete this.stores[storeKey];
    };
    MainAppStore.prototype._getStoreMethod = function (storeKey, winId, method, index) {
        var store = this.stores[this._getStoreKey(storeKey, winId)];
        if (!store) {
            throw new Error("The store " + storeKey + " for winId " + winId + " is not exists");
        }
        if (index !== undefined) {
            store = store.get(index);
            if (!store) {
                throw new Error("The store " + storeKey + "'s sub key " + index + " store is not exists");
            }
        }
        if (!store[method]) {
            throw new Error("The store " + storeKey + "'s method " + method + " is not exists");
        }
        return store[method].bind(store);
    };
    MainAppStore.prototype._handleRendererPayload = function (winId, payload) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, storeKey, method, index, args, result;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this.deserializer(payload), storeKey = _a.store, method = _a.method, index = _a.index, args = _a.args;
                        return [4 /*yield*/, this._getStoreMethod(storeKey, winId, method, index).apply(void 0, __spread(args))];
                    case 1:
                        result = _b.sent();
                        return [2 /*return*/, result];
                }
            });
        });
    };
    MainAppStore.prototype.handleRendererDispatch = function (winId, invokeId, stringifiedAction) {
        var _this = this;
        var winInfo = this.multiWinSaver.getWinInfo(winId);
        if (!winInfo) {
            return;
        }
        return this._handleRendererPayload(winId, stringifiedAction).then(function (result) {
            _this.mainClient.sendWinMsg(winInfo, constants_1.mainReturnName, invokeId, undefined, result !== undefined ? _this.serializer(result) : result);
        }, function (err) {
            var errObj = null;
            if (err) {
                errObj = { name: err.name, message: err.message };
                if (errObj) {
                    Object.keys(err).forEach(function (key) { return (errObj[key] = err[key]); });
                }
            }
            _this.mainClient.sendWinMsg(winInfo, constants_1.mainReturnName, invokeId, errObj, undefined);
            if (process.env.NODE_ENV === "development") {
                throw err;
            }
        });
    };
    MainAppStore.prototype.handleRendererDispatchNoReturn = function (winId, stringifiedAction) {
        var winInfo = this.multiWinSaver.getWinInfo(winId);
        if (!winInfo) {
            return;
        }
        this._handleRendererPayload(winId, stringifiedAction);
    };
    MainAppStore.prototype.handleRendererDispatchObserve = function (winId, invokeId, action) {
        var _this = this;
        var storeKey = action.store, method = action.method, index = action.index;
        var storeMethod = this._getStoreMethod(storeKey, winId, method, index);
        this.winObserves[winId][invokeId] = storeMethod(function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            var winInfo = _this.multiWinSaver.getWinInfo(winId);
            if (!winInfo) {
                return;
            }
            _this.mainClient.sendWinMsg(winInfo, constants_1.mainInvokeName, invokeId, args);
        });
    };
    MainAppStore.prototype.handleRendererDispatchDispose = function (winId, invokeId) {
        var disposable = this.winObserves[winId][invokeId];
        if (disposable) {
            disposable.dispose();
            delete this.winObserves[winId][invokeId];
        }
    };
    MainAppStore.prototype.handleWinMessage = function (senderId, targetId, data) {
        var _this = this;
        var winInfo = this.multiWinSaver.getWinInfo(targetId);
        if (!winInfo) {
            return;
        }
        this.multiWinSaver.whenRegister(winInfo.winId, function () {
            _this.mainClient.sendWinMsg(winInfo, constants_1.winMessageName, senderId, data);
        });
    };
    MainAppStore.prototype.handleRegisterWin = function (winId) {
        // If the winId has registered, that may be hot reload, we need delete the window and add again.
        if (this.multiWinSaver.isRegister(winId)) {
            var winInfo = this.multiWinSaver.getWinInfo(winId);
            this.multiWinSaver.deleteWin(winId);
            this.multiWinSaver.addWin(winInfo);
            this.initWin(winId, { state: this.getInitStates(winId) });
        }
        else {
            this.multiWinSaver.registerWin(winId);
        }
    };
    MainAppStore.prototype.initWin = function (winId, params) {
        var _this = this;
        var winInfo = this.multiWinSaver.getWinInfo(winId);
        if (!winInfo) {
            return;
        }
        this.multiWinSaver.whenRegister(winInfo.winId, function () {
            _this.mainClient.sendWinMsg(winInfo, constants_1.initMessageName, params);
        });
    };
    MainAppStore.prototype._applyFilterForStore = function (winFilter, winId, storeKeys, forAdd) {
        var e_2, _a;
        var newFilter = __assign({}, winFilter);
        try {
            for (var storeKeys_1 = __values(storeKeys), storeKeys_1_1 = storeKeys_1.next(); !storeKeys_1_1.done; storeKeys_1_1 = storeKeys_1.next()) {
                var storeKey = storeKeys_1_1.value;
                var depList = [storeKey];
                for (var i = 0; i < depList.length; i += 1) {
                    var curStoreKey = depList[i];
                    var storeDeclarer = this._storeRegisterMap[curStoreKey];
                    if (!storeDeclarer) {
                        console.error("The store key " + curStoreKey + " is not registered");
                    }
                    var depStoreNames = storeDeclarer.depStoreNames, options = storeDeclarer.options;
                    var filterKey = this._getStateKey(curStoreKey, options.stateKey, winId);
                    if (forAdd ? newFilter[filterKey] : newFilter[filterKey] === undefined) {
                        continue;
                    }
                    if (forAdd) {
                        newFilter[filterKey] = this.storeMapModes[curStoreKey] === event_flux_1.OperateMode.RefCount ? {} : true;
                    }
                    else {
                        delete newFilter[filterKey];
                    }
                    depList.splice.apply(depList, __spread([depList.length, 0], (depStoreNames || [])));
                }
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (storeKeys_1_1 && !storeKeys_1_1.done && (_a = storeKeys_1.return)) _a.call(storeKeys_1);
            }
            finally { if (e_2) throw e_2.error; }
        }
        return newFilter;
    };
    MainAppStore.prototype.handleRequestStores = function (winId, storeKeys) {
        var e_3, _a;
        var winStores = this.winHoldStores[winId];
        try {
            for (var storeKeys_2 = __values(storeKeys), storeKeys_2_1 = storeKeys_2.next(); !storeKeys_2_1.done; storeKeys_2_1 = storeKeys_2.next()) {
                var storeKey = storeKeys_2_1.value;
                if (winStores.has(storeKey)) {
                    console.error("The store " + storeKey + " for win " + winId + " has requested, This may be renderer bug ");
                    continue;
                }
                winStores.add(storeKey);
                this.requestStore(storeKey, winId);
            }
        }
        catch (e_3_1) { e_3 = { error: e_3_1 }; }
        finally {
            try {
                if (storeKeys_2_1 && !storeKeys_2_1.done && (_a = storeKeys_2.return)) _a.call(storeKeys_2);
            }
            finally { if (e_3) throw e_3.error; }
        }
        // Update the store's filter for this window
        var winFilter = this.winFilters[winId];
        var newFilter = this._applyFilterForStore(winFilter, winId, storeKeys, true);
        this.forwardDeltaFilter(winId, winFilter, newFilter);
        this.winFilters[winId] = newFilter;
    };
    MainAppStore.prototype.handleReleaseStores = function (winId, storeKeys) {
        var e_4, _a;
        var winStores = this.winHoldStores[winId];
        try {
            for (var storeKeys_3 = __values(storeKeys), storeKeys_3_1 = storeKeys_3.next(); !storeKeys_3_1.done; storeKeys_3_1 = storeKeys_3.next()) {
                var storeKey = storeKeys_3_1.value;
                if (!winStores.has(storeKey)) {
                    console.error("The store " + storeKey + " for win " + winId + " has released, This may be renderer bug ");
                    continue;
                }
                this.releaseStore(storeKey, winId);
                winStores.delete(storeKey);
            }
        }
        catch (e_4_1) { e_4 = { error: e_4_1 }; }
        finally {
            try {
                if (storeKeys_3_1 && !storeKeys_3_1.done && (_a = storeKeys_3.return)) _a.call(storeKeys_3);
            }
            finally { if (e_4) throw e_4.error; }
        }
        // Update the store's filter for this window
        var winFilter = this.winFilters[winId];
        var newFilter = this._applyFilterForStore(winFilter, winId, storeKeys, false);
        this.forwardDeltaFilter(winId, winFilter, newFilter);
        this.winFilters[winId] = newFilter;
    };
    MainAppStore.prototype.handleMapRequestStores = function (winId, storeKey, mapKeys) {
        var e_5, _a, e_6, _b, _c, _d;
        var _this = this;
        var winStores = this.winHoldStores[winId];
        try {
            for (var mapKeys_1 = __values(mapKeys), mapKeys_1_1 = mapKeys_1.next(); !mapKeys_1_1.done; mapKeys_1_1 = mapKeys_1.next()) {
                var mapKey = mapKeys_1_1.value;
                var mapStoreKey = storeKey + "@" + mapKey;
                if (winStores.has(mapStoreKey)) {
                    console.error("The map store " + storeKey + "'s " + mapKey + " for win " + winId + " has requested, This may be renderer bug ");
                    continue;
                }
                winStores.add(mapStoreKey);
                var store = this.stores[this._getStoreKey(storeKey, winId)];
                store.requestStore(mapKey);
            }
        }
        catch (e_5_1) { e_5 = { error: e_5_1 }; }
        finally {
            try {
                if (mapKeys_1_1 && !mapKeys_1_1.done && (_a = mapKeys_1.return)) _a.call(mapKeys_1);
            }
            finally { if (e_5) throw e_5.error; }
        }
        // StoreMap's OperateMode change from Direct to RefCount,
        // then this storeMap filter for all the win should change to {}
        if (this.storeMapModes[storeKey] !== event_flux_1.OperateMode.RefCount) {
            this.storeMapModes[storeKey] = event_flux_1.OperateMode.RefCount;
            var options_1 = this._storeRegisterMap[storeKey].options;
            this.multiWinSaver.winInfos.forEach(function (winInfo) {
                var filterKey = _this._getStateKey(storeKey, options_1.stateKey, winInfo.winId);
                var winFilter = _this.winFilters[winInfo.winId];
                winFilter[filterKey] = {};
            });
        }
        // Update this winId's storeMap filter and forward this filter to renderer process.
        var thisWinFilter = this.winFilters[winId];
        var thisOptions = this._storeRegisterMap[storeKey].options;
        var thisStateKey = this._getStateKey(storeKey, thisOptions.stateKey, winId);
        var mapFilter = thisWinFilter[thisStateKey];
        var newMapFilter = __assign({}, mapFilter);
        try {
            for (var mapKeys_2 = __values(mapKeys), mapKeys_2_1 = mapKeys_2.next(); !mapKeys_2_1.done; mapKeys_2_1 = mapKeys_2.next()) {
                var mapKey = mapKeys_2_1.value;
                newMapFilter[mapKey] = true;
            }
        }
        catch (e_6_1) { e_6 = { error: e_6_1 }; }
        finally {
            try {
                if (mapKeys_2_1 && !mapKeys_2_1.done && (_b = mapKeys_2.return)) _b.call(mapKeys_2);
            }
            finally { if (e_6) throw e_6.error; }
        }
        this.forwardDeltaFilter(winId, (_c = {}, _c[thisStateKey] = mapFilter, _c), (_d = {}, _d[thisStateKey] = newMapFilter, _d));
        thisWinFilter[thisStateKey] = newMapFilter;
    };
    MainAppStore.prototype.handleMapReleaseStores = function (winId, storeKey, mapKeys) {
        var e_7, _a, e_8, _b, _c, _d;
        var winStores = this.winHoldStores[winId];
        try {
            for (var mapKeys_3 = __values(mapKeys), mapKeys_3_1 = mapKeys_3.next(); !mapKeys_3_1.done; mapKeys_3_1 = mapKeys_3.next()) {
                var mapKey = mapKeys_3_1.value;
                var mapStoreKey = storeKey + "@" + mapKey;
                if (!winStores.has(mapStoreKey)) {
                    console.error("The map store " + storeKey + "'s " + mapKey + " for win " + winId + " has released, This may be renderer bug ");
                    continue;
                }
                winStores.delete(mapStoreKey);
                var store = this.stores[this._getStoreKey(storeKey, winId)];
                store.releaseStore(mapKey);
            }
        }
        catch (e_7_1) { e_7 = { error: e_7_1 }; }
        finally {
            try {
                if (mapKeys_3_1 && !mapKeys_3_1.done && (_a = mapKeys_3.return)) _a.call(mapKeys_3);
            }
            finally { if (e_7) throw e_7.error; }
        }
        // Update this winId's storeMap filter and forward this filter to renderer process.
        var winFilter = this.winFilters[winId];
        var options = this._storeRegisterMap[storeKey].options;
        var thisStateKey = this._getStateKey(storeKey, options.stateKey, winId);
        var mapFilter = winFilter[thisStateKey];
        var newMapFilter = __assign({}, mapFilter);
        try {
            for (var mapKeys_4 = __values(mapKeys), mapKeys_4_1 = mapKeys_4.next(); !mapKeys_4_1.done; mapKeys_4_1 = mapKeys_4.next()) {
                var mapKey = mapKeys_4_1.value;
                delete newMapFilter[mapKey];
            }
        }
        catch (e_8_1) { e_8 = { error: e_8_1 }; }
        finally {
            try {
                if (mapKeys_4_1 && !mapKeys_4_1.done && (_b = mapKeys_4.return)) _b.call(mapKeys_4);
            }
            finally { if (e_8) throw e_8.error; }
        }
        this.forwardDeltaFilter(winId, (_c = {}, _c[thisStateKey] = mapFilter, _c), (_d = {}, _d[thisStateKey] = newMapFilter, _d));
        winFilter[thisStateKey] = newMapFilter;
    };
    MainAppStore.prototype.getStoreDeclarers = function () {
        return this.outStoreDeclarers;
    };
    MainAppStore.prototype._transformWinState = function (finalState) {
        // Transform the win specific state that remove the window suffix
        for (var stateKey in finalState) {
            var _a = __read(stateKey.split("@"), 2), realKey = _a[0], id = _a[1];
            if (id) {
                finalState[realKey] = finalState[stateKey];
                delete finalState[stateKey];
            }
        }
        return finalState;
    };
    MainAppStore.prototype.getInitStates = function (winId) {
        var e_9, _a;
        var winFilter = this.winFilters[winId];
        var state = this.prevState;
        var finalState = {};
        // Generate the new final state by the win filter
        for (var iFilter in winFilter) {
            if (Array.isArray(iFilter)) {
                var _b = __read(iFilter, 2), stateKey = _b[0], keys = _b[1];
                finalState[stateKey] = {};
                try {
                    for (var keys_1 = (e_9 = void 0, __values(keys)), keys_1_1 = keys_1.next(); !keys_1_1.done; keys_1_1 = keys_1.next()) {
                        var key = keys_1_1.value;
                        finalState[stateKey][key] = state[stateKey][key];
                    }
                }
                catch (e_9_1) { e_9 = { error: e_9_1 }; }
                finally {
                    try {
                        if (keys_1_1 && !keys_1_1.done && (_a = keys_1.return)) _a.call(keys_1);
                    }
                    finally { if (e_9) throw e_9.error; }
                }
            }
            else {
                finalState[iFilter] = state[iFilter];
            }
        }
        return this.serializer(this._transformWinState(finalState));
    };
    MainAppStore.prototype.handleWillChange = function (prevState, state) {
        this.forwardState(prevState, state);
    };
    MainAppStore.prototype.forwardState = function (prevState, state) {
        var _this = this;
        var delta = objectDifference_1.default(prevState, state);
        if (objUtils_1.isEmpty(delta.updated) && objUtils_1.isEmpty(delta.deleted)) {
            return;
        }
        var winFilters = this.winFilters;
        this.multiWinSaver.winInfos.forEach(function (client) {
            var winId = client.winId;
            var filterUpdated = filterApply_1.default(delta.updated, winFilters[winId]);
            var filterDeleted = filterApply_1.default(delta.deleted, winFilters[winId]);
            filterUpdated = _this._transformWinState(filterUpdated);
            filterDeleted = _this._transformWinState(filterDeleted);
            // let [updated, deleted] = filterWindowDelta(filterUpdated, filterDeleted, winManagerKey, clientId);
            if (!objUtils_1.isEmpty(filterUpdated) || !objUtils_1.isEmpty(filterDeleted)) {
                var action = { updated: filterUpdated, deleted: filterDeleted };
                _this.mainClient.sendWinMsg(client, constants_1.mainDispatchName, _this.serializer(action));
            }
        });
    };
    MainAppStore.prototype.forwardDeltaFilter = function (winId, prevFilter, newFilter) {
        var _a = filterDifference_1.default(prevFilter, newFilter), updated = _a.updated, deleted = _a.deleted;
        var updateState = filterApply_1.default(this.prevState, updated);
        updated = this._transformWinState(updateState);
        deleted = this._transformWinState(deleted);
        if (!objUtils_1.isEmpty(updated) || !objUtils_1.isEmpty(deleted)) {
            var action = { updated: updated, deleted: deleted };
            this.mainClient.sendWinMsg(this.multiWinSaver.getWinInfo(winId), constants_1.mainDispatchName, this.serializer(action));
        }
    };
    return MainAppStore;
}(event_flux_1.AppStore));
exports.default = MainAppStore;
