import { StoreBase } from "event-flux";
import { IWinProps, IWinParams, IMultiWinStore } from "./mainClientTypes";
import MainAppStore from "./MainAppStore";
import { IMainClient } from "./mainClientTypes";
import MultiWinSaver from "./MultiWinSaver";
export default class MultiWinStore extends StoreBase<any> implements IMultiWinStore {
    clientIds: string[];
    clientIdNameMap: {
        [clientId: string]: string;
    };
    clientNameIdMap: {
        [winName: string]: string;
    };
    groupsMap: {
        [clientId: string]: string[];
    };
    mainClient: IMainClient;
    multiWinSaver: MultiWinSaver;
    constructor(appStore: MainAppStore);
    init(): void;
    _addWinProps(clientId: string, winProps: IWinProps): void;
    _updateWinProps(clientId: string, winProps: IWinProps): void;
    _parseWinProps(winProps: string | IWinProps, parentId?: string | null): IWinProps;
    _removeClientId(clientId: string): void;
    createWin(winProps: IWinProps | string, params?: IWinParams): string | null;
    createOrOpenWin(winName: string, url: string | IWinProps, params: any): string | null;
    closeWin(clientId: string): void;
    closeWinByName(name: string): void;
    closeWinByGroup(group: string): void;
    activeWin(clientId: string): void;
    activeWindow(clientId: string): void;
    activeWinByName(name: string): void;
    activeWinByGroup(group: string): void;
    sendWinMsg(clientId: string, message: any): void;
    sendWinMsgByName(name: string, message: any): void;
    sendWinMsgByGroup(group: string, message: any): void;
    changeWinProps(clientId: string, winProps: IWinProps): void;
    _genClientId(): string;
    closeAllWindows(): void;
}
//# sourceMappingURL=MultiWinStore.d.ts.map