"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var event_flux_1 = require("event-flux");
var constants_1 = require("./constants");
var RendererClient_1 = __importDefault(require("./RendererClient"));
var StoreProxy_1 = require("./storeProxy/StoreProxy");
var objectMerge_1 = __importDefault(require("./utils/objectMerge"));
var StoreListProxy_1 = require("./storeProxy/StoreListProxy");
var StoreMapProxy_1 = require("./storeProxy/StoreMapProxy");
var event_kit_1 = require("event-kit");
var WindowProxy_1 = __importDefault(require("./WindowProxy"));
var json_immutable_bn_1 = require("json-immutable-bn");
var IDGenerator = /** @class */ (function () {
    function IDGenerator() {
        this.count = 0;
    }
    IDGenerator.prototype.genID = function () {
        return ++this.count;
    };
    return IDGenerator;
}());
var RendererAppStore = /** @class */ (function (_super) {
    __extends(RendererAppStore, _super);
    function RendererAppStore(storeDeclarers, options) {
        var e_1, _a;
        var _this = _super.call(this) || this;
        _this.idGenerator = new IDGenerator();
        _this.resolveMap = {};
        _this.mainInvokeMap = {};
        _this.emitter = new event_kit_1.Emitter();
        if (!storeDeclarers) {
            storeDeclarers = [];
        }
        _this.serializer = (options && options.serializer) || json_immutable_bn_1.serialize;
        _this.deserializer = (options && options.deserializer) || json_immutable_bn_1.deserialize;
        var ClientClass = (options && options.RendererClient) || RendererClient_1.default;
        _this.rendererClient = new ClientClass(_this);
        var _b = _this.rendererClient.getQuery(), mainDeclarersStr = _b.storeDeclarers, state = _b.state, clientId = _b.winId, winProps = __rest(_b, ["storeDeclarers", "state", "winId"]);
        if (typeof window === "object") {
            window.eventFluxWin = winProps;
            window.winId = clientId;
            window.parentId = winProps.parentId;
            window.parentWin = new WindowProxy_1.default(_this, winProps.parentId);
        }
        _this.winId = clientId;
        _this.rendererClient.sendMainMsg(constants_1.renderRegisterName, clientId);
        var mainDeclarers = JSON.parse(mainDeclarersStr);
        try {
            for (var mainDeclarers_1 = __values(mainDeclarers), mainDeclarers_1_1 = mainDeclarers_1.next(); !mainDeclarers_1_1.done; mainDeclarers_1_1 = mainDeclarers_1.next()) {
                var storeDeclarer = mainDeclarers_1_1.value;
                var ProxyDeclarer = void 0;
                var storeType = storeDeclarer.storeType, depStoreNames = storeDeclarer.depStoreNames, declarerOptions = __rest(storeDeclarer, ["storeType", "depStoreNames"]);
                switch (storeType) {
                    case "Item":
                        ProxyDeclarer = StoreProxy_1.StoreProxyDeclarer;
                        break;
                    case "List":
                        ProxyDeclarer = StoreListProxy_1.StoreListProxyDeclarer;
                        break;
                    case "Map":
                        ProxyDeclarer = StoreMapProxy_1.StoreMapProxyDeclarer;
                        break;
                    default:
                        ProxyDeclarer = StoreProxy_1.StoreProxyDeclarer;
                }
                declarerOptions.forMain = true;
                storeDeclarers.push(new ProxyDeclarer(StoreProxy_1.StoreProxy, depStoreNames, declarerOptions));
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (mainDeclarers_1_1 && !mainDeclarers_1_1.done && (_a = mainDeclarers_1.return)) _a.call(mainDeclarers_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        _this.registerStore.apply(_this, __spread(storeDeclarers));
        var initStates = _this.deserializer(state);
        if (initStates) {
            _this.__initStates__ = initStates;
            _this.state = initStates;
        }
        return _this;
    }
    RendererAppStore.prototype.handleDispatchReturn = function (actionStr) {
        var _a = this.deserializer(actionStr), updated = _a.updated, deleted = _a.deleted;
        this.state = objectMerge_1.default(this.state, updated, deleted);
        this.batchUpdater.requestUpdate();
    };
    RendererAppStore.prototype.handleInvokeReturn = function (invokeId, error, result) {
        // this.idGenerator.dispose(invokeId);
        var _a = this.resolveMap[invokeId], resolve = _a.resolve, reject = _a.reject;
        delete this.resolveMap[invokeId];
        if (error) {
            return reject(error);
        }
        if (result !== undefined) {
            result = this.deserializer(result);
        }
        resolve(result);
    };
    RendererAppStore.prototype.handleMainInvoke = function (invokeId, args) {
        var callback = this.mainInvokeMap[invokeId];
        callback && callback.apply(void 0, __spread(args));
    };
    // When renderer process receive message
    RendererAppStore.prototype.handleMessage = function (data) {
        this.emitter.emit("did-message", data);
    };
    // When renderer process receive win message
    RendererAppStore.prototype.handleWinMessage = function (senderId, data) {
        this.emitter.emit("did-win-message", { senderId: senderId, data: data });
    };
    // When renderer process receive init message
    RendererAppStore.prototype.handleInit = function (data) {
        if (typeof window === "object") {
            var storeDeclarers = data.storeDeclarers, state = data.state, winId = data.winId, winProps = __rest(data, ["storeDeclarers", "state", "winId"]);
            window.eventFluxWin = __assign({}, window.eventFluxWin, winProps);
            if (winProps.parentId) {
                window.parentId = winProps.parentId;
                window.parentWin.changeWinId(winProps.parentId);
            }
            if (state) {
                this.state = __assign({}, this.state, this.deserializer(state));
                this._sendUpdate();
            }
            this.emitter.emit("did-init", window.eventFluxWin);
        }
    };
    RendererAppStore.prototype.onDidMessage = function (callback) {
        return this.emitter.on("did-message", callback);
    };
    RendererAppStore.prototype.onDidWinMessage = function (callback) {
        return this.emitter.on("did-win-message", callback);
    };
    RendererAppStore.prototype.onDidInit = function (callback) {
        return this.emitter.on("did-init", callback);
    };
    RendererAppStore.prototype.handleMainRequestStores = function (storeNames) {
        this.rendererClient.sendMainMsg(constants_1.renderRequestStoreName, this.winId, storeNames);
    };
    RendererAppStore.prototype.handleMainReleaseStores = function (storeNames) {
        this.rendererClient.sendMainMsg(constants_1.renderReleaseStoreName, this.winId, storeNames);
    };
    RendererAppStore.prototype.handleMainMapRequestStores = function (storeName, mapKeys) {
        this.rendererClient.sendMainMsg(constants_1.renderMapRequestStoreName, this.winId, storeName, mapKeys);
    };
    RendererAppStore.prototype.handleMainMapReleaseStores = function (storeName, mapKeys) {
        this.rendererClient.sendMainMsg(constants_1.renderMapReleaseStoreName, this.winId, storeName, mapKeys);
    };
    RendererAppStore.prototype.sendWindowMessage = function (sourceId, targetId, data) {
        this.rendererClient.sendMainMsg(constants_1.winMessageName, sourceId, targetId, data);
    };
    RendererAppStore.prototype.handleDispatch = function (dispatchInfo) {
        var _this = this;
        var invokeId = this.idGenerator.genID();
        this.rendererClient.sendMainMsg(constants_1.renderDispatchName, this.winId, invokeId, this.serializer(dispatchInfo));
        return new Promise(function (thisResolve, thisReject) { return (_this.resolveMap[invokeId] = { resolve: thisResolve, reject: thisReject }); });
    };
    RendererAppStore.prototype.handleDispatchNoReturn = function (dispatchInfo) {
        this.rendererClient.sendMainMsg(constants_1.renderDispatchNoReturnName, this.winId, this.serializer(dispatchInfo));
    };
    RendererAppStore.prototype.handleDispatchDisposable = function (dispatchInfo, callback) {
        var _this = this;
        var invokeId = this.idGenerator.genID();
        this.mainInvokeMap[invokeId] = callback;
        this.rendererClient.sendMainMsg(constants_1.renderDispatchObserve, this.winId, invokeId, dispatchInfo);
        return {
            dispose: function () {
                _this.rendererClient.sendMainMsg(constants_1.renderDispatchDispose, _this.winId, invokeId);
                delete _this.mainInvokeMap[invokeId];
            },
        };
    };
    /**
     * Find the storeKey's dependencies that will need create in main process.
     * @param storeKey
     */
    RendererAppStore.prototype.findMainDepList = function (storeKey) {
        var depList = [storeKey];
        var mainDepList = new Set();
        for (var i = 0; i < depList.length; i += 1) {
            var curStoreKey = depList[i];
            var storeInfo = this._storeRegisterMap[curStoreKey];
            if (!storeInfo) {
                console.error("The request store " + curStoreKey + " is not registered!");
                continue;
            }
            if (storeInfo.options.forMain && !mainDepList.has(curStoreKey)) {
                mainDepList.add(curStoreKey);
                continue;
            }
            var depNames = storeInfo.depStoreNames || [];
            depList.splice.apply(depList, __spread([depList.length, 0], depNames));
        }
        return Array.from(mainDepList);
    };
    RendererAppStore.prototype._createStoreAndInject = function (storeKey) {
        var mainDepList = this.findMainDepList(storeKey);
        if (mainDepList.length > 0) {
            this.handleMainRequestStores(mainDepList);
        }
        return _super.prototype._createStoreAndInject.call(this, storeKey);
    };
    RendererAppStore.prototype._disposeStoreAndDeps = function (storeKey, store) {
        var mainDepList = this.findMainDepList(storeKey);
        if (mainDepList.length > 0) {
            this.handleMainReleaseStores(mainDepList);
        }
        return _super.prototype._disposeStoreAndDeps.call(this, storeKey, store);
    };
    return RendererAppStore;
}(event_flux_1.AppStore));
exports.default = RendererAppStore;
