"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var event_kit_1 = require("event-kit");
var WindowProxy = /** @class */ (function () {
    function WindowProxy(store, winId) {
        this.emitter = new event_kit_1.Emitter();
        this.store = store;
        this.winId = winId;
        this.store.onDidWinMessage(this.handleWinMessage.bind(this));
    }
    WindowProxy.prototype.changeWinId = function (winId) {
        this.winId = winId;
    };
    WindowProxy.prototype.send = function (message) {
        if (this.winId) {
            this.store.sendWindowMessage(this.store.winId, this.winId, message);
        }
    };
    WindowProxy.prototype.handleWinMessage = function (_a) {
        var senderId = _a.senderId, data = _a.data;
        if (senderId === this.winId) {
            this.emitter.emit("message", data);
        }
    };
    WindowProxy.prototype.onDidReceiveMsg = function (callback) {
        return this.emitter.on("message", callback);
    };
    return WindowProxy;
}());
exports.default = WindowProxy;
