/// <reference types="node" />
import { EventEmitter } from "events";
declare class FakeWebContents {
    _isDestroyed: boolean;
    _isCrashed: boolean;
    channels: any[];
    isDestroyed(): boolean;
    isCrashed(): boolean;
    send(channel: string, ...args: any[]): void;
}
declare class FakeBrowserWindow extends EventEmitter {
    props: any;
    url: any;
    webContents: FakeWebContents;
    _isMinimized: boolean;
    _isMaximized: boolean;
    _isFullScreen: boolean;
    _bounds: Rectangle;
    _contentBounds: Rectangle;
    constructor(props: any);
    loadURL(url: any): void;
    show(): void;
    maximize(): void;
    unmaximize(): void;
    isMaximized(): boolean;
    minimize(): void;
    restore(): void;
    isMinimized(): boolean;
    setFullScreen(flag: boolean): void;
    isFullScreen(): boolean;
    setBounds(bounds: Rectangle): void;
    getBounds(): Rectangle;
    setContentBounds(bounds: Rectangle): void;
    getContentBounds(): Rectangle;
    isDestroyed(): boolean;
    close(): void;
}
interface Rectangle {
    x: number;
    y: number;
    width: number;
    height: number;
}
export declare const ipcMain: EventEmitter;
export declare const ipcRenderer: EventEmitter;
export declare const BrowserWindow: typeof FakeBrowserWindow;
export declare const screen: {
    getDisplayMatching(rect: Rectangle): {
        bounds: Rectangle;
    };
    getPrimaryDisplay(): {
        size: {
            width: number;
            height: number;
        };
    };
};
export declare const Event: () => void;
export declare const WebContents: typeof FakeWebContents;
export declare const app: {
    whenReady(): Promise<void>;
};
export {};
//# sourceMappingURL=electron.d.ts.map