"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var events_1 = require("events");
var FakeWebContents = /** @class */ (function () {
    function FakeWebContents() {
        this._isDestroyed = false;
        this._isCrashed = false;
        this.channels = [];
    }
    FakeWebContents.prototype.isDestroyed = function () {
        return this._isDestroyed;
    };
    FakeWebContents.prototype.isCrashed = function () {
        return this._isCrashed;
    };
    FakeWebContents.prototype.send = function (channel) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        this.channels.push(__spread([channel], args));
    };
    return FakeWebContents;
}());
var FakeBrowserWindow = /** @class */ (function (_super) {
    __extends(FakeBrowserWindow, _super);
    function FakeBrowserWindow(props) {
        var _this = _super.call(this) || this;
        _this._isMinimized = false;
        _this._isMaximized = false;
        _this._isFullScreen = false;
        _this._bounds = { x: 0, y: 0, width: 100, height: 100 };
        _this._contentBounds = { x: 0, y: 0, width: 100, height: 100 };
        _this.props = props;
        if (props && typeof props.x === "number" && typeof props.y === "number" && props.width && props.height) {
            _this._bounds = _this._contentBounds = { x: props.x, y: props.y, width: props.width, height: props.height };
        }
        _this.webContents = new FakeWebContents();
        return _this;
    }
    FakeBrowserWindow.prototype.loadURL = function (url) {
        this.url = url;
    };
    FakeBrowserWindow.prototype.show = function () {
        this.props.show = true;
    };
    FakeBrowserWindow.prototype.maximize = function () {
        this._isMaximized = true;
    };
    FakeBrowserWindow.prototype.unmaximize = function () {
        this._isMaximized = false;
    };
    FakeBrowserWindow.prototype.isMaximized = function () {
        return this._isMaximized;
    };
    FakeBrowserWindow.prototype.minimize = function () {
        this._isMinimized = true;
    };
    FakeBrowserWindow.prototype.restore = function () {
        this._isMinimized = false;
    };
    FakeBrowserWindow.prototype.isMinimized = function () {
        return this._isMinimized;
    };
    FakeBrowserWindow.prototype.setFullScreen = function (flag) {
        this._isFullScreen = flag;
    };
    FakeBrowserWindow.prototype.isFullScreen = function () {
        return this._isFullScreen;
    };
    FakeBrowserWindow.prototype.setBounds = function (bounds) {
        this._bounds = bounds;
        this.emit("resize", {});
    };
    FakeBrowserWindow.prototype.getBounds = function () {
        return this._bounds;
    };
    FakeBrowserWindow.prototype.setContentBounds = function (bounds) {
        this._contentBounds = bounds;
        this.emit("resize", {});
    };
    FakeBrowserWindow.prototype.getContentBounds = function () {
        return this._contentBounds;
    };
    FakeBrowserWindow.prototype.isDestroyed = function () {
        return false;
    };
    FakeBrowserWindow.prototype.close = function () {
        this.emit("close", {});
        this.emit("closed", {});
    };
    return FakeBrowserWindow;
}(events_1.EventEmitter));
exports.ipcMain = new events_1.EventEmitter();
exports.ipcRenderer = new events_1.EventEmitter();
exports.BrowserWindow = FakeBrowserWindow;
exports.screen = {
    getDisplayMatching: function (rect) {
        return {
            bounds: { x: 0, y: 0, width: 1200, height: 800 },
        };
    },
    getPrimaryDisplay: function () {
        return { size: { width: 1200, height: 800 } };
    },
};
exports.Event = function () { };
exports.WebContents = FakeWebContents;
exports.app = {
    whenReady: function () {
        return Promise.resolve();
    },
};
