"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var event_flux_1 = require("event-flux");
var StoreDeclarer_1 = require("../StoreDeclarer");
var TodoStore = /** @class */ (function (_super) {
    __extends(TodoStore, _super);
    function TodoStore(appStore) {
        var _this = _super.call(this, appStore) || this;
        _this.state = { todo2: "todo2" };
        return _this;
    }
    return TodoStore;
}(event_flux_1.StoreBase));
jest.useFakeTimers();
describe("WinStoreDeclarer", function () {
    test("should create normally for 2 params", function () {
        var storeDeclarer = StoreDeclarer_1.declareWinStore(TodoStore, { args: "hello" });
        expect(storeDeclarer.Store).toBe(TodoStore);
        expect(storeDeclarer.depStoreNames).toEqual([]);
        expect(storeDeclarer.options).toEqual({ storeKey: "todoStore", stateKey: "todo", args: "hello", isPerWin: true });
    });
    test("should create normally for 3 params", function () {
        var storeDeclarer = StoreDeclarer_1.declareWinStore(TodoStore, ["todo2", "todo3"], { args: "hello" });
        expect(storeDeclarer.Store).toBe(TodoStore);
        expect(storeDeclarer.depStoreNames).toEqual(["todo2", "todo3"]);
        expect(storeDeclarer.options).toEqual({ storeKey: "todoStore", stateKey: "todo", args: "hello", isPerWin: true });
    });
});
describe("WinStoreListDeclarer", function () {
    test("should create normally for 2 params", function () {
        var storeDeclarer = StoreDeclarer_1.declareWinStoreList(TodoStore, { args: ["hello"] });
        expect(storeDeclarer.Store).toBe(TodoStore);
        expect(storeDeclarer.depStoreNames).toEqual([]);
        expect(storeDeclarer.options).toEqual({ storeKey: "todoStore", stateKey: "todo", args: ["hello"], isPerWin: true });
    });
    test("should create normally for 3 params", function () {
        var storeDeclarer = StoreDeclarer_1.declareWinStore(TodoStore, ["todo2", "todo3"], { args: "hello" });
        expect(storeDeclarer.Store).toBe(TodoStore);
        expect(storeDeclarer.depStoreNames).toEqual(["todo2", "todo3"]);
        expect(storeDeclarer.options).toEqual({ storeKey: "todoStore", stateKey: "todo", args: "hello", isPerWin: true });
    });
});
describe("WinStoreMapDeclarer", function () {
    test("should create normally for 2 params", function () {
        var storeDeclarer = StoreDeclarer_1.declareWinStoreMap(TodoStore, { args: ["hello"] });
        expect(storeDeclarer.Store).toBe(TodoStore);
        expect(storeDeclarer.depStoreNames).toEqual([]);
        expect(storeDeclarer.options).toEqual({ storeKey: "todoStore", stateKey: "todo", args: ["hello"], isPerWin: true });
    });
    test("should create normally for 3 params", function () {
        var storeDeclarer = StoreDeclarer_1.declareWinStoreMap(TodoStore, ["todo2", "todo3"], { args: ["hello"] });
        expect(storeDeclarer.Store).toBe(TodoStore);
        expect(storeDeclarer.depStoreNames).toEqual(["todo2", "todo3"]);
        expect(storeDeclarer.options).toEqual({ storeKey: "todoStore", stateKey: "todo", args: ["hello"], isPerWin: true });
    });
});
