"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var constants_1 = require("../constants");
var queryHandler_1 = require("../utils/queryHandler");
var BrowserRendererClient = /** @class */ (function () {
    function BrowserRendererClient(rendererCallback) {
        var _this = this;
        this.rendererCallback = rendererCallback;
        this.query = queryHandler_1.decodeQuery(window.location.search.slice(1));
        this.winId = this.query.winId || "mainClient";
        window.addEventListener("message", this._handleMessage.bind(this));
        window.addEventListener("unload", function () {
            _this.sendMainMsg("close", _this.winId);
        });
    }
    BrowserRendererClient.prototype.getQuery = function () {
        return this.query;
    };
    BrowserRendererClient.prototype.sendMainMsg = function (msgName) {
        var params = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            params[_i - 1] = arguments[_i];
        }
        var mainWin = this.winId === "mainClient" ? window : window.opener;
        mainWin.postMessage({ action: msgName, data: params }, "*");
    };
    BrowserRendererClient.prototype._handleMessage = function (event) {
        var _a = event.data || {}, action = _a.action, data = _a.data;
        switch (action) {
            case constants_1.mainDispatchName:
                return this.rendererCallback.handleDispatchReturn(data[0]);
            case constants_1.mainReturnName: {
                var _b = __read(data, 3), invokeId = _b[0], error = _b[1], result = _b[2];
                return this.rendererCallback.handleInvokeReturn(invokeId, error, result);
            }
            case constants_1.mainInvokeName: {
                var _c = __read(data, 2), invokeId = _c[0], args = _c[1];
                return this.rendererCallback.handleMainInvoke(invokeId, args);
            }
            case constants_1.messageName: {
                return this.rendererCallback.handleMessage(data[0]);
            }
            case constants_1.winMessageName: {
                var _d = __read(data, 2), senderId = _d[0], payload = _d[1];
                return this.rendererCallback.handleWinMessage(senderId, payload);
            }
            case constants_1.initMessageName: {
                return this.rendererCallback.handleInit(data[0]);
            }
        }
    };
    return BrowserRendererClient;
}());
exports.default = BrowserRendererClient;
