"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var BrowserMainClient_1 = __importDefault(require("../BrowserMainClient"));
var MultiWinSaver_1 = __importDefault(require("../../MultiWinSaver"));
var constants_1 = require("../../constants");
describe("BrowserMainClient", function () {
    var multiWinSaver;
    var mainClientCallback;
    var mainClient;
    beforeEach(function () {
        multiWinSaver = new MultiWinSaver_1.default();
        mainClientCallback = {
            handleRendererDispatch: jest.fn(),
            handleRendererDispatchNoReturn: jest.fn(),
            handleRendererDispatchObserve: jest.fn(),
            handleRendererDispatchDispose: jest.fn(),
            handleWinMessage: jest.fn(),
            handleRequestStores: jest.fn(),
            handleReleaseStores: jest.fn(),
            handleMapRequestStores: jest.fn(),
            handleMapReleaseStores: jest.fn(),
            handleRegisterWin: jest.fn(),
            initWin: jest.fn(),
            getStoreDeclarers: jest.fn(),
            getInitStates: jest.fn(),
        };
        mainClient = new BrowserMainClient_1.default(multiWinSaver, mainClientCallback);
    });
    afterEach(function () {
        window.removeEventListener("message", mainClient._handleMessage);
        mainClient = undefined;
        delete window.isMainClient;
    });
    test("should handle incoming messages and add default window", function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    expect(window.isMainClient).toBeTruthy();
                    expect(multiWinSaver.winInfos).toEqual([{ winId: "mainClient", window: window }]);
                    multiWinSaver.addWin({ winId: "win1", window: window });
                    window.postMessage({ action: constants_1.renderRegisterName, data: ["win1"] }, "*");
                    return [4 /*yield*/, new Promise(function (resolve) { return setTimeout(resolve, 0); })];
                case 1:
                    _a.sent();
                    expect(mainClientCallback.handleRegisterWin).toHaveBeenLastCalledWith("win1");
                    window.postMessage({ action: "close", data: ["win1"] }, "*");
                    return [4 /*yield*/, new Promise(function (resolve) { return setTimeout(resolve, 0); })];
                case 2:
                    _a.sent();
                    expect(multiWinSaver.winInfos).toEqual([{ winId: "mainClient", window: window }]);
                    window.postMessage({ action: constants_1.renderDispatchName, data: ["win1", 12, "hello"] }, "*");
                    return [4 /*yield*/, new Promise(function (resolve) { return setTimeout(resolve, 0); })];
                case 3:
                    _a.sent();
                    expect(mainClientCallback.handleRendererDispatch).toHaveBeenLastCalledWith("win1", 12, "hello");
                    window.postMessage({ action: constants_1.renderDispatchObserve, data: ["win1", 12, { store: "helloStore" }] }, "*");
                    return [4 /*yield*/, new Promise(function (resolve) { return setTimeout(resolve, 0); })];
                case 4:
                    _a.sent();
                    expect(mainClientCallback.handleRendererDispatchObserve).toHaveBeenLastCalledWith("win1", 12, {
                        store: "helloStore",
                    });
                    window.postMessage({ action: constants_1.renderDispatchDispose, data: ["win1", 12] }, "*");
                    return [4 /*yield*/, new Promise(function (resolve) { return setTimeout(resolve, 0); })];
                case 5:
                    _a.sent();
                    expect(mainClientCallback.handleRendererDispatchDispose).toHaveBeenLastCalledWith("win1", 12);
                    window.postMessage({ action: constants_1.renderRequestStoreName, data: ["win1", ["key1", "key2"]] }, "*");
                    return [4 /*yield*/, new Promise(function (resolve) { return setTimeout(resolve, 0); })];
                case 6:
                    _a.sent();
                    expect(mainClientCallback.handleRequestStores).toHaveBeenLastCalledWith("win1", ["key1", "key2"]);
                    window.postMessage({ action: constants_1.renderReleaseStoreName, data: ["win1", ["key1", "key2"]] }, "*");
                    return [4 /*yield*/, new Promise(function (resolve) { return setTimeout(resolve, 0); })];
                case 7:
                    _a.sent();
                    expect(mainClientCallback.handleRequestStores).toHaveBeenLastCalledWith("win1", ["key1", "key2"]);
                    window.postMessage({ action: constants_1.winMessageName, data: ["win1", "win2", "data"] }, "*");
                    return [4 /*yield*/, new Promise(function (resolve) { return setTimeout(resolve, 0); })];
                case 8:
                    _a.sent();
                    expect(mainClientCallback.handleWinMessage).toHaveBeenLastCalledWith("win1", "win2", "data");
                    return [2 /*return*/];
            }
        });
    }); });
    test("sendWinMsg should can post message", function () { return __awaiter(_this, void 0, void 0, function () {
        var onMessage;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    onMessage = jest.fn();
                    window.addEventListener("message", onMessage);
                    mainClient.sendWinMsg({ winId: "win1", window: window }, "msg1", "arg1", "arg2");
                    return [4 /*yield*/, new Promise(function (resolve) { return setTimeout(resolve, 0); })];
                case 1:
                    _a.sent();
                    expect(onMessage.mock.calls[0][0].data).toEqual({ action: "msg1", data: ["arg1", "arg2"] });
                    return [2 /*return*/];
            }
        });
    }); });
    test("createWin should can create the new window", function () {
        var originOpen = window.open;
        var mockOpen = jest.fn(function () {
            var retWin = {
                onbeforeunload: function () { },
                close: function () {
                    retWin.onbeforeunload && retWin.onbeforeunload();
                },
            };
            return retWin;
        });
        window.open = mockOpen;
        var newWin = mainClient.createWin("win1", { path: "/hello", parentId: "win2", name: "win1", groups: ["hello"] }, { minWidth: 300 });
        expect(mockOpen.mock.calls[0][0]).toBe("http://localhost/hello?path=%2Fhello&parentId=win2&name=win1&groups=hello&winId=win1&isSlave=1");
        expect(mockOpen.mock.calls[0][2].split(",")[0]).toBe("minWidth=300");
        expect(multiWinSaver.winInfos).toEqual([{ winId: "mainClient", window: window }, { winId: "win1", window: newWin }]);
        newWin.close();
        expect(multiWinSaver.winInfos).toEqual([{ winId: "mainClient", window: window }]);
        window.open = originOpen;
    });
});
