"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var constants_1 = require("../constants");
var electron_1 = require("electron");
var queryHandler_1 = require("../utils/queryHandler");
var ElectronRendererClient = /** @class */ (function () {
    function ElectronRendererClient(rendererCallback) {
        var _this = this;
        this.rendererCallback = rendererCallback;
        this.query = queryHandler_1.decodeQuery(window.location.search.slice(1));
        this.winId = this.query.winId || "mainClient";
        electron_1.ipcRenderer.on(constants_1.mainDispatchName, function (event, args) {
            _this.rendererCallback.handleDispatchReturn(args);
        });
        electron_1.ipcRenderer.on(constants_1.mainReturnName, function (event, invokeId, error, result) {
            _this.rendererCallback.handleInvokeReturn(invokeId, error, result);
        });
        electron_1.ipcRenderer.on(constants_1.mainInvokeName, function (event, invokeId, args) {
            _this.rendererCallback.handleMainInvoke(invokeId, args);
        });
        electron_1.ipcRenderer.on(constants_1.messageName, function (event, params) {
            _this.rendererCallback.handleMessage(params);
        });
        electron_1.ipcRenderer.on(constants_1.winMessageName, function (event, senderId, params) {
            _this.rendererCallback.handleWinMessage(senderId, params);
        });
        electron_1.ipcRenderer.on(constants_1.initMessageName, function (event, arg) {
            _this.rendererCallback.handleInit(arg);
        });
    }
    ElectronRendererClient.prototype.getQuery = function () {
        return this.query;
    };
    ElectronRendererClient.prototype.sendMainMsg = function (msgName) {
        var params = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            params[_i - 1] = arguments[_i];
        }
        electron_1.ipcRenderer.send.apply(electron_1.ipcRenderer, __spread([msgName], params));
    };
    return ElectronRendererClient;
}());
exports.default = ElectronRendererClient;
