import { BrowserWindow } from "electron";
declare type OnSave = (state: any) => void;
export interface IWinState {
    x?: number;
    y?: number;
    width?: number;
    height?: number;
    useContentSize?: boolean;
    isMaximized?: boolean;
    isFullScreen?: boolean;
}
interface IWinConfig {
    defaultX?: number;
    defaultY?: number;
    defaultWidth?: number;
    defaultHeight?: number;
    useContentSize?: boolean;
}
export default class ElectronWindowState {
    onSave: OnSave | null;
    state: IWinState;
    winRef: any;
    stateChangeTimer: any;
    constructor(config: any, state: IWinState, onSave: OnSave | null);
    loadState(state: IWinState, config: IWinConfig): void;
    normState(state: IWinState, config: IWinConfig): void;
    isNormal(win: BrowserWindow): boolean;
    validateState(state: IWinState): void;
    updateState(): void;
    stateChangeHandler(): void;
    closeHandler(): void;
    closedHandler(): void;
    manage(win: BrowserWindow): void;
    unmanage(): void;
}
export {};
//# sourceMappingURL=ElectronWindowState.d.ts.map