import MultiWinStore from "../MultiWinStore";
import { IWinState } from "./ElectronWindowState";
import { BrowserWindow } from "electron";
import IStorage from "../storage/IStorage";
import { IWinProps, IWinParams } from "../mainClientTypes";
export declare class WindowManager {
    windows: Array<{
        clientId: string;
        window: BrowserWindow;
    }>;
    winHandler: any;
    winSize: number;
    constructor(winHandler: MultiWinCacheStore);
    genClientId(): string;
    createWin(clientId: string): any;
    ensureWindows(): void;
    getWin(): {
        clientId: string;
        window: BrowserWindow;
    } | undefined;
    dispose(): void;
}
interface IClientCacheInfo {
    parentId?: string | null;
    winId: string;
    name?: string;
    groups?: string[];
    path?: string;
    winState?: IWinState;
    [key: string]: any;
}
declare class MultiWinCacheStore extends MultiWinStore {
    clientInfoMap: {
        [winId: string]: IClientCacheInfo;
    };
    willQuit: boolean;
    windowManager?: WindowManager;
    _storage?: IStorage;
    init(): void;
    loadClients(): void;
    saveClients(): void;
    getDefaultClients(): IClientCacheInfo[];
    getStorage(): IStorage;
    _removeClientId(clientId: string): void;
    handleDidCloseWin(winId: string): void;
    saveWinState(clientId: string, winState: IWinState): void;
    createWinForClientId(winProps: IWinProps, clientId: string, params: IWinParams): string | null;
    createWin(winProps: IWinProps | string, params: IWinParams): string | null;
    _createWinForElectron(winProps: IWinProps | string, params: IWinParams): string | null;
    _createElectronWin(url: string | IWinProps, clientId: string | null, params: IWinState): string | null;
    _getElectronWinFromCache(url: string, clientId: string | null, parentId: string | null | undefined, params: IWinParams): {
        clientId: string;
        win: BrowserWindow;
    };
    createNativeWindow(clientId: string, url: string | undefined, parentId: string | null | undefined, params: IWinParams): BrowserWindow;
    createMainWindow(url: string, clientId: string, parentId: string | null | undefined, params?: any): BrowserWindow;
    handleClosed(clientId: string): void;
    changeWinProps(clientId: string, winProps: IWinProps): void;
    closeAllWindows(): void;
}
export default MultiWinCacheStore;
//# sourceMappingURL=MultiWinCacheStore.d.ts.map