"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var electron_1 = require("electron");
var ElectronMainClient_1 = __importDefault(require("../ElectronMainClient"));
var MultiWinSaver_1 = __importDefault(require("../../MultiWinSaver"));
var constants_1 = require("../../constants");
var queryHandler_1 = require("../../utils/queryHandler");
jest.useFakeTimers();
describe("ElectronMainClient", function () {
    var multiWinSaver;
    var mainClientCallback;
    var mainClient;
    beforeEach(function () {
        multiWinSaver = new MultiWinSaver_1.default();
        mainClientCallback = {
            handleRendererDispatch: jest.fn(),
            handleRendererDispatchNoReturn: jest.fn(),
            handleRendererDispatchObserve: jest.fn(),
            handleRendererDispatchDispose: jest.fn(),
            handleWinMessage: jest.fn(),
            handleRequestStores: jest.fn(),
            handleReleaseStores: jest.fn(),
            handleMapRequestStores: jest.fn(),
            handleMapReleaseStores: jest.fn(),
            handleRegisterWin: jest.fn(),
            initWin: jest.fn(),
            getStoreDeclarers: jest.fn(),
            getInitStates: jest.fn(),
        };
        mainClient = new ElectronMainClient_1.default(multiWinSaver, mainClientCallback);
    });
    afterEach(function () {
        mainClient = undefined;
    });
    test("should handle incoming messages", function () { return __awaiter(_this, void 0, void 0, function () {
        var window;
        return __generator(this, function (_a) {
            window = new electron_1.BrowserWindow({ x: 10 });
            multiWinSaver.addWin({ winId: "win1", window: window, webContents: window.webContents });
            electron_1.ipcMain.emit(constants_1.renderRegisterName, {}, "win1");
            expect(mainClientCallback.handleRegisterWin).toHaveBeenLastCalledWith("win1");
            electron_1.ipcMain.emit(constants_1.renderDispatchName, {}, "win1", 12, "hello");
            expect(mainClientCallback.handleRendererDispatch).toHaveBeenLastCalledWith("win1", 12, "hello");
            electron_1.ipcMain.emit(constants_1.renderDispatchObserve, {}, "win1", 12, { store: "helloStore" });
            expect(mainClientCallback.handleRendererDispatchObserve).toHaveBeenCalledWith("win1", 12, { store: "helloStore" });
            electron_1.ipcMain.emit(constants_1.renderDispatchDispose, {}, "win1", 12);
            expect(mainClientCallback.handleRendererDispatchDispose).toHaveBeenCalledWith("win1", 12);
            electron_1.ipcMain.emit(constants_1.renderRequestStoreName, {}, "win1", ["key1", "key2"]);
            expect(mainClientCallback.handleRequestStores).toHaveBeenLastCalledWith("win1", ["key1", "key2"]);
            electron_1.ipcMain.emit(constants_1.renderReleaseStoreName, {}, "win1", ["key1", "key2"]);
            expect(mainClientCallback.handleReleaseStores).toHaveBeenLastCalledWith("win1", ["key1", "key2"]);
            electron_1.ipcMain.emit(constants_1.winMessageName, {}, "win1", "win2", "data");
            expect(mainClientCallback.handleWinMessage).toHaveBeenLastCalledWith("win1", "win2", "data");
            return [2 /*return*/];
        });
    }); });
    test("sendWinMsg should can post message", function () { return __awaiter(_this, void 0, void 0, function () {
        var window;
        return __generator(this, function (_a) {
            window = new electron_1.BrowserWindow({ x: 10 });
            mainClient.sendWinMsg({ winId: "win1", window: window, webContents: window.webContents }, "msg1", "arg1", "arg2");
            expect(window.webContents.channels).toEqual([["msg1", "arg1", "arg2"]]);
            return [2 /*return*/];
        });
    }); });
    test("createWin should can create the new window", function () {
        var newWin = mainClient.createWin("win1", { path: "/hello", parentId: "win2", name: "win1", groups: ["hello"] }, { minWidth: 300 });
        var loadUrl = require("url").parse(newWin.url);
        expect(queryHandler_1.decodeQuery(loadUrl.query)).toEqual({
            path: "/hello",
            parentId: "win2",
            name: "win1",
            groups: "hello",
            winId: "win1",
        });
        expect(newWin.props).toEqual({ minWidth: 300, show: false, webPreferences: { nodeIntegration: true } });
        expect(multiWinSaver.winInfos).toEqual([{ winId: "win1", window: newWin, webContents: newWin.webContents }]);
        newWin.emit("closed");
        expect(multiWinSaver.winInfos).toEqual([]);
    });
    test("changeWin should can change the window props", function () {
        var newWin = mainClient.createWin("win1", { path: "/hello", parentId: "win2", name: "win1", groups: ["hello"] }, { minWidth: 300, show: false });
        newWin.setContentBounds = jest.fn();
        newWin.setBounds = jest.fn();
        newWin.setMinimumSize = jest.fn();
        newWin.setMaximumSize = jest.fn();
        newWin.setTitle = jest.fn();
        newWin.show = jest.fn();
        mainClient.changeWin(multiWinSaver.getWinInfo("win1"), { path: "/home" }, {
            useContentSize: true,
            x: 1,
            width: 150,
            height: 150,
            minWidth: 100,
            minHeight: 100,
            maxWidth: 200,
            maxHeight: 200,
            title: "hello",
            show: true,
        });
        expect(newWin.setMinimumSize).toHaveBeenLastCalledWith(100, 100);
        expect(newWin.setMaximumSize).toHaveBeenLastCalledWith(200, 200);
        expect(newWin.setTitle).toHaveBeenLastCalledWith("hello");
        expect(newWin.setContentBounds).toHaveBeenLastCalledWith({ x: 1, y: 0, width: 150, height: 150 });
        jest.runAllTimers();
        expect(newWin.show).toHaveBeenCalled();
    });
});
