"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var MainAppStore_1 = __importDefault(require("../../MainAppStore"));
var MultiWinCacheStore_1 = __importStar(require("../MultiWinCacheStore"));
var electron_1 = require("electron");
jest.useFakeTimers();
jest.mock("../../MainClient", function () {
    var MyMainClient = /** @class */ (function () {
        function MyMainClient(multiWinSaver) {
            var _this = this;
            this.multiWinSaver = multiWinSaver;
            this.sendWinMsg = jest.fn();
            this.activeWin = jest.fn();
            this.createWin = jest.fn(function (winId) {
                var win = new electron_1.BrowserWindow();
                _this.multiWinSaver.addWin({ winId: winId, window: win });
                win.on("closed", function () {
                    _this.multiWinSaver.deleteWin(winId);
                });
                return win;
            });
            this.changeWin = jest.fn();
            this.closeWin = jest.fn(function (winInfo) {
                winInfo.window.close();
            });
        }
        return MyMainClient;
    }());
    return MyMainClient;
});
var MyStorage = /** @class */ (function () {
    function MyStorage() {
        this._storage = {};
    }
    MyStorage.prototype.set = function (key, value) {
        if (typeof key === "object") {
            for (var k in key) {
                this.set(k, key[k]);
            }
        }
        else {
            this._storage[key] = value;
        }
    };
    MyStorage.prototype.get = function (key, defaultValue) {
        return this._storage[key] || defaultValue;
    };
    MyStorage.prototype.delete = function (key) {
        delete this._storage[key];
    };
    MyStorage.prototype.getNSStore = function (namespace) {
        return this;
    };
    return MyStorage;
}());
describe("MultiWinStore", function () {
    var multiWinStore;
    var appStore;
    beforeEach(function () {
        appStore = new MainAppStore_1.default();
        multiWinStore = new MultiWinCacheStore_1.default(appStore);
        var storage = new MyStorage();
        multiWinStore.getStorage = function () { return storage; };
    });
    test("loadClients should generate default client when storage not contain clients", function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    multiWinStore.getStorage().set("clients", []);
                    multiWinStore.init();
                    return [4 /*yield*/, electron_1.app.whenReady()];
                case 1:
                    _a.sent();
                    expect(multiWinStore.clientIds).toEqual(["mainClient"]);
                    expect(multiWinStore.clientIdNameMap.mainClient).toBe("mainClient");
                    expect(multiWinStore.groupsMap.mainClient).toEqual(["main"]);
                    return [2 /*return*/];
            }
        });
    }); });
    test("WindowManager should can get window", function () { return __awaiter(_this, void 0, void 0, function () {
        var winManager, winInfo;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    winManager = new MultiWinCacheStore_1.WindowManager(multiWinStore);
                    return [4 /*yield*/, electron_1.app.whenReady()];
                case 1:
                    _a.sent();
                    expect(winManager.windows.length).toBe(winManager.winSize);
                    winInfo = winManager.getWin();
                    expect(winManager.windows.length).toBe(winManager.winSize);
                    expect(multiWinStore.multiWinSaver.getWinInfos().length).toEqual(2);
                    winManager.dispose();
                    expect(multiWinStore.multiWinSaver.getWinInfos().length).toEqual(1);
                    return [2 /*return*/];
            }
        });
    }); });
    test("loadClients with clients should behave correctly", function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    multiWinStore
                        .getStorage()
                        .set("clients", [
                        { winId: "mainClient", name: "mainClient", groups: ["main"], path: "/home", winState: { x: 10 } },
                        { winId: "win1", name: "win1", groups: ["main"], path: "/home2", winState: { y: 20 } },
                    ]);
                    multiWinStore.init();
                    return [4 /*yield*/, electron_1.app.whenReady()];
                case 1:
                    _a.sent();
                    expect(appStore.mainClient.createWin).toHaveBeenNthCalledWith(2, "mainClient", { path: "/home", parentId: undefined }, { x: 10, y: 0, width: 800, height: 600, useContentSize: false });
                    expect(appStore.mainClient.createWin).toHaveBeenNthCalledWith(3, "win1", { path: "/home2", parentId: undefined }, { x: 0, y: 20, width: 800, height: 600, useContentSize: false });
                    expect(multiWinStore.clientIds).toEqual(["mainClient", "win1"]);
                    expect(multiWinStore.clientIdNameMap).toEqual({ mainClient: "mainClient", win1: "win1" });
                    expect(multiWinStore.groupsMap).toEqual({ mainClient: ["main"], win1: ["main"] });
                    expect(Object.keys(multiWinStore.clientInfoMap)).toEqual(["mainClient", "win1"]);
                    expect(multiWinStore.clientInfoMap.mainClient).toEqual({
                        path: "/home",
                        winId: "mainClient",
                        groups: ["main"],
                        name: "mainClient",
                        winState: {
                            x: 10,
                            y: 0,
                            width: 800,
                            height: 600,
                            useContentSize: false,
                        },
                    });
                    return [2 /*return*/];
            }
        });
    }); });
    test("create window should behave correctly", function () { return __awaiter(_this, void 0, void 0, function () {
        var win1Id;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    multiWinStore.getStorage().set("clients", []);
                    multiWinStore.init();
                    return [4 /*yield*/, electron_1.app.whenReady()];
                case 1:
                    _a.sent();
                    appStore.multiWinSaver.getWinInfo("mainClient").window.setBounds({ x: 100, y: 100, width: 1000, height: 700 });
                    multiWinStore.createWin({ path: "/hello", name: "hello", parentId: "mainClient" }, {});
                    win1Id = multiWinStore.clientIds[1];
                    expect(appStore.mainClient.changeWin).toHaveBeenLastCalledWith(appStore.multiWinSaver.getWinInfo(win1Id), { path: "/hello", parentId: "mainClient" }, { x: 200, y: 150, width: 800, height: 600, useContentSize: false });
                    expect(multiWinStore.clientInfoMap[multiWinStore.clientIds[1]]).toEqual({
                        path: "/hello",
                        winId: multiWinStore.clientIds[1],
                        name: "hello",
                        parentId: "mainClient",
                        groups: ["main"],
                        winState: {
                            x: 200,
                            y: 150,
                            width: 800,
                            height: 600,
                            useContentSize: false,
                        },
                    });
                    multiWinStore.createWin({ path: "/hello", name: "hello" }, {});
                    expect(appStore.mainClient.changeWin).toHaveBeenLastCalledWith(appStore.multiWinSaver.getWinInfo(multiWinStore.clientIds[2]), { path: "/hello", parentId: undefined }, { x: 200, y: 100, width: 800, height: 600, useContentSize: false });
                    expect(multiWinStore.getStorage().get("clients").length).toEqual(3);
                    appStore.multiWinSaver.getWinInfo(multiWinStore.clientIds[2]).window.close();
                    expect(multiWinStore.clientIds.length).toBe(2);
                    expect(Object.keys(multiWinStore.clientInfoMap).length).toBe(2);
                    appStore.multiWinSaver.getWinInfo("mainClient").window.close();
                    expect(multiWinStore.clientIds.length).toBe(0);
                    expect(Object.keys(multiWinStore.clientInfoMap).length).toBe(0);
                    expect(multiWinStore.clientIdNameMap).toEqual({});
                    expect(multiWinStore
                        .getStorage()
                        .get("clients")
                        .map(function (item) { return item.winId; })).toEqual(["mainClient", win1Id]);
                    return [2 /*return*/];
            }
        });
    }); });
    test("loadClients with clients should behave correctly", function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    multiWinStore
                        .getStorage()
                        .set("clients", [
                        { winId: "mainClient", name: "mainClient", groups: ["main"], path: "/home", winState: { x: 10 } },
                    ]);
                    multiWinStore.init();
                    return [4 /*yield*/, electron_1.app.whenReady()];
                case 1:
                    _a.sent();
                    multiWinStore.changeWinProps("mainClient", { path: "/home2" });
                    expect(multiWinStore.getStorage().get("clients")).toMatchObject([
                        { winId: "mainClient", path: "/home2", name: "mainClient", groups: ["main"], winState: { x: 10 } },
                    ]);
                    return [2 /*return*/];
            }
        });
    }); });
});
