import { DispatchItem, StoreBaseConstructor } from "event-flux";
import { DisposableLike } from "event-kit";
export interface IDispatchInfo {
    store: string;
    index?: string | number;
    method: string;
    args?: any[];
}
export interface IStoreDispatcher {
    handleDispatch(dispatchInfo: IDispatchInfo): void;
    handleDispatchNoReturn(dispatchInfo: IDispatchInfo): void;
    handleDispatchDisposable(dispatchInfo: IDispatchInfo, callback: (...args: any[]) => void): DisposableLike;
    handleMainMapRequestStores?(storeName: string, mapKeys: string[]): void;
    handleMainMapReleaseStores?(storeName: string, mapKeys: string[]): void;
}
export default class DispatchItemProxy implements DispatchItem {
    _refCount: number;
    _stateKey: string | undefined;
    _init(): void;
    _inject(StoreBuilder: StoreBaseConstructor<any>, stateKey?: string): void;
    dispose(): void;
    _addRef(): void;
    _decreaseRef(): void;
    getRefCount(): number;
    [property: string]: any;
}
//# sourceMappingURL=DispatchItemProxy.d.ts.map