import DispatchItemProxy, { IStoreDispatcher } from "./DispatchItemProxy";
import { IWinProps, IWinParams } from "../mainClientTypes";
import RendererAppStore from "../RendererAppStore";
import { Emitter } from "event-kit";
export declare class ChildWindowProxy {
    emitter: Emitter<{
        [key: string]: any;
    }, {}>;
    store: RendererAppStore;
    messages: any[];
    childId: any;
    constructor(store: RendererAppStore, createPromise: Promise<string>);
    send(message: any): void;
    handleWinMessage({ senderId, data }: {
        senderId: string;
        data: string;
    }): void;
    onDidReceiveMsg(callback: (message: any) => void): import("event-kit").Disposable;
}
export declare class MultiWinStoreProxy extends DispatchItemProxy {
    appStore: RendererAppStore;
    storeKey: string;
    evs: Set<string>;
    invokers: Set<string>;
    constructor(appStore: IStoreDispatcher, storeKey: string, evs: string[], invokers: string[]);
    createWin(url: IWinProps | string, params: IWinParams): ChildWindowProxy;
    createOrOpenWin(winName: string, url: string | IWinProps, params: IWinParams): ChildWindowProxy;
}
//# sourceMappingURL=MultiWinStoreProxy.d.ts.map