"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var DispatchItemProxy_1 = __importDefault(require("./DispatchItemProxy"));
var StoreProxy_1 = require("./StoreProxy");
var event_kit_1 = require("event-kit");
var ChildWindowProxy = /** @class */ (function () {
    function ChildWindowProxy(store, createPromise) {
        var _this = this;
        this.emitter = new event_kit_1.Emitter();
        this.messages = [];
        this.store = store;
        this.messages = [];
        createPromise.then(function (childId) {
            _this.childId = childId;
            _this.messages.forEach(function (message) {
                _this.send(message);
            });
            _this.messages = [];
        });
        this.store.onDidWinMessage(this.handleWinMessage.bind(this));
    }
    ChildWindowProxy.prototype.send = function (message) {
        if (!this.childId) {
            this.messages.push(message);
        }
        else {
            this.store.sendWindowMessage(this.store.winId, this.childId, message);
        }
    };
    ChildWindowProxy.prototype.handleWinMessage = function (_a) {
        var senderId = _a.senderId, data = _a.data;
        if (senderId === this.childId) {
            this.emitter.emit("message", data);
        }
    };
    ChildWindowProxy.prototype.onDidReceiveMsg = function (callback) {
        return this.emitter.on("message", callback);
    };
    return ChildWindowProxy;
}());
exports.ChildWindowProxy = ChildWindowProxy;
var MultiWinStoreProxy = /** @class */ (function (_super) {
    __extends(MultiWinStoreProxy, _super);
    function MultiWinStoreProxy(appStore, storeKey, evs, invokers) {
        var _this = _super.call(this) || this;
        _this.invokers = new Set();
        _this.appStore = appStore;
        _this.storeKey = storeKey;
        _this.evs = new Set(evs);
        _this.invokers = new Set(invokers);
        return StoreProxy_1.proxyStore(appStore, _this, storeKey);
    }
    MultiWinStoreProxy.prototype.createWin = function (url, params) {
        var parentId = window.winId;
        var result = this.appStore.handleDispatch({
            store: this.storeKey,
            method: "createWin",
            args: [url, parentId, params],
        });
        return new ChildWindowProxy(this.appStore, result);
    };
    MultiWinStoreProxy.prototype.createOrOpenWin = function (winName, url, params) {
        var parentId = window.winId;
        var result = this.appStore.handleDispatch({
            store: this.storeKey,
            method: "createOrOpenWin",
            args: [winName, url, parentId, params],
        });
        return new ChildWindowProxy(this.appStore, result);
    };
    return MultiWinStoreProxy;
}(DispatchItemProxy_1.default));
exports.MultiWinStoreProxy = MultiWinStoreProxy;
