"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var event_flux_1 = require("event-flux");
var DispatchItemProxy_1 = __importDefault(require("./DispatchItemProxy"));
var StoreListItemProxy = /** @class */ (function (_super) {
    __extends(StoreListItemProxy, _super);
    function StoreListItemProxy(appStore, storeKey, indexKey) {
        var _this = _super.call(this) || this;
        return new Proxy(_this, {
            get: function (target, property, receiver) {
                if (target[property] != null) {
                    return target[property];
                }
                return function () {
                    var args = [];
                    for (var _i = 0; _i < arguments.length; _i++) {
                        args[_i] = arguments[_i];
                    }
                    return appStore.handleDispatch({ store: storeKey, index: indexKey, method: property, args: args });
                };
            },
        });
    }
    return StoreListItemProxy;
}(DispatchItemProxy_1.default));
var StoreListProxy = /** @class */ (function (_super) {
    __extends(StoreListProxy, _super);
    function StoreListProxy(appStore, storeKey) {
        var _this = _super.call(this) || this;
        _this.length = 0;
        _this.storeArray = [];
        _this._appStore = appStore;
        _this._storeKey = storeKey;
        return _this;
    }
    StoreListProxy.prototype._inject = function (StoreBuilder, stateKey, depStores, initState, options) {
        this._stateKey = stateKey;
        var size = options.size || 0;
        if (size > 0) {
            this.setSize(size);
        }
    };
    StoreListProxy.prototype.setSize = function (count) {
        if (this.length === count) {
            return;
        }
        this._appStore.handleDispatchNoReturn({ store: this._storeKey, method: "setSize", args: [count] });
        if (this.length < count) {
            for (var i = this.length; i < count; ++i) {
                this.storeArray.push(new StoreListItemProxy(this._appStore, this._storeKey, i));
            }
        }
        else {
            this.storeArray.splice(count, this.length - count);
        }
        this.length = count;
    };
    StoreListProxy.prototype.get = function (index) {
        return this.storeArray[index];
    };
    return StoreListProxy;
}(DispatchItemProxy_1.default));
exports.StoreListProxy = StoreListProxy;
var StoreListProxyDeclarer = /** @class */ (function (_super) {
    __extends(StoreListProxyDeclarer, _super);
    function StoreListProxyDeclarer() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    StoreListProxyDeclarer.prototype.create = function (appStore) {
        return new StoreListProxy(appStore, this.options.storeKey);
    };
    return StoreListProxyDeclarer;
}(event_flux_1.StoreListDeclarer));
exports.StoreListProxyDeclarer = StoreListProxyDeclarer;
