"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var event_flux_1 = require("event-flux");
var DispatchItemProxy_1 = __importDefault(require("./DispatchItemProxy"));
var MultiWinStoreProxy_1 = require("./MultiWinStoreProxy");
var MethodType;
(function (MethodType) {
    MethodType[MethodType["Simple"] = 0] = "Simple";
    MethodType[MethodType["EV"] = 1] = "EV";
    MethodType[MethodType["Invoker"] = 2] = "Invoker";
})(MethodType || (MethodType = {}));
function proxyStore(appStore, store, storeKey) {
    return new Proxy(store, {
        get: function (target, property, receiver) {
            if (target[property] != null) {
                return target[property];
            }
            var methodType = MethodType.Simple;
            if (target.evs.has(property)) {
                methodType = MethodType.EV;
            }
            else if (target.invokers.has(property)) {
                methodType = MethodType.Invoker;
            }
            return function () {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                switch (methodType) {
                    case MethodType.Simple:
                        return appStore.handleDispatchNoReturn({ store: storeKey, method: property, args: args });
                    case MethodType.EV:
                        return appStore.handleDispatchDisposable({ store: storeKey, method: property }, args[0]);
                    case MethodType.Invoker:
                        return appStore.handleDispatch({ store: storeKey, method: property, args: args });
                }
            };
        },
    });
}
exports.proxyStore = proxyStore;
var StoreProxy = /** @class */ (function (_super) {
    __extends(StoreProxy, _super);
    function StoreProxy(appStore, storeKey, evs, invokers) {
        var _this = _super.call(this) || this;
        _this.invokers = new Set();
        _this.evs = new Set(evs);
        _this.invokers = new Set(invokers);
        return proxyStore(appStore, _this, storeKey);
    }
    return StoreProxy;
}(DispatchItemProxy_1.default));
exports.StoreProxy = StoreProxy;
var StoreProxyDeclarer = /** @class */ (function (_super) {
    __extends(StoreProxyDeclarer, _super);
    function StoreProxyDeclarer() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    StoreProxyDeclarer.prototype.create = function (appStore) {
        var _a = this.options, storeKey = _a.storeKey, _evs = _a._evs, _invokers = _a._invokers;
        if (storeKey === "multiWinStore") {
            return new MultiWinStoreProxy_1.MultiWinStoreProxy(appStore, storeKey, _evs, _invokers);
        }
        return new StoreProxy(appStore, storeKey, _evs, _invokers);
    };
    return StoreProxyDeclarer;
}(event_flux_1.StoreDeclarer));
exports.StoreProxyDeclarer = StoreProxyDeclarer;
