"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var MultiWinStoreProxy_1 = require("../MultiWinStoreProxy");
var event_kit_1 = require("event-kit");
jest.useFakeTimers();
describe("StoreProxy", function () {
    var originWinId;
    beforeEach(function () {
        originWinId = window.winId;
        window.winId = "winId2";
    });
    afterEach(function () {
        window.winId = originWinId;
    });
    test("should can proxy other methods", function () { return __awaiter(_this, void 0, void 0, function () {
        var StoreDispatcher, storeDispatcher, newStore, childProxy, dispatchRes, observer;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    StoreDispatcher = /** @class */ (function () {
                        function StoreDispatcher() {
                            this.winId = "curWin";
                            this.emitter = new event_kit_1.Emitter();
                            this.handleDispatch = jest.fn(function () {
                                return new Promise(function (resolve, reject) {
                                    setTimeout(function () { return resolve("childWin"); }, 0);
                                });
                            });
                            this.handleDispatchNoReturn = jest.fn();
                            this.handleDispatchDisposable = jest.fn();
                            this.sendWindowMessage = jest.fn();
                        }
                        StoreDispatcher.prototype.onDidWinMessage = function (callback) {
                            this.emitter.on("did-message", callback);
                        };
                        StoreDispatcher.prototype.sendMsg = function (senderId, data) {
                            this.emitter.emit("did-message", { senderId: senderId, data: data });
                        };
                        return StoreDispatcher;
                    }());
                    storeDispatcher = new StoreDispatcher();
                    newStore = new MultiWinStoreProxy_1.MultiWinStoreProxy(storeDispatcher, "helloStore", [], []);
                    newStore.hello("hello");
                    expect(storeDispatcher.handleDispatchNoReturn).toHaveBeenLastCalledWith({
                        store: "helloStore",
                        method: "hello",
                        args: ["hello"],
                    });
                    childProxy = newStore.createWin("/hello", { x: 10, y: 10 });
                    expect(storeDispatcher.handleDispatch).toHaveBeenLastCalledWith({
                        store: "helloStore",
                        method: "createWin",
                        args: ["/hello", "winId2", { x: 10, y: 10 }],
                    });
                    childProxy.send("hello");
                    expect(childProxy.messages).toEqual(["hello"]);
                    dispatchRes = storeDispatcher.handleDispatch();
                    jest.runAllTimers();
                    return [4 /*yield*/, dispatchRes];
                case 1:
                    _a.sent();
                    expect(storeDispatcher.sendWindowMessage).toHaveBeenCalledWith("curWin", "childWin", "hello");
                    expect(childProxy.messages).toEqual([]);
                    childProxy.send("world");
                    expect(storeDispatcher.sendWindowMessage).toHaveBeenCalledWith("curWin", "childWin", "world");
                    observer = jest.fn();
                    childProxy.onDidReceiveMsg(observer);
                    storeDispatcher.sendMsg("childWin", "children");
                    expect(observer).toHaveBeenCalledWith("children");
                    return [2 /*return*/];
            }
        });
    }); });
});
