"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var StoreProxy_1 = require("../StoreProxy");
var event_flux_1 = require("event-flux");
describe("StoreProxy", function () {
    test("should can proxy other methods", function () {
        var storeDispatcher = {
            handleDispatch: jest.fn(),
            handleDispatchNoReturn: jest.fn(),
            handleDispatchDisposable: jest.fn(),
        };
        var newStore = new StoreProxy_1.StoreProxy(storeDispatcher, "helloStore", ["onDidUpdate"], ["doInvoke"]);
        newStore._inject(event_flux_1.StoreBase, "stateKey");
        newStore._init();
        newStore._addRef();
        expect(newStore._stateKey).toEqual("stateKey");
        expect(newStore._refCount).toEqual(1);
        expect(newStore.getRefCount()).toBe(1);
        expect(newStore._decreaseRef());
        expect(newStore.getRefCount()).toBe(0);
        newStore.hello("hello");
        expect(storeDispatcher.handleDispatchNoReturn).toHaveBeenLastCalledWith({
            store: "helloStore",
            method: "hello",
            args: ["hello"],
        });
        newStore.doInvoke("hello");
        expect(storeDispatcher.handleDispatch).toHaveBeenLastCalledWith({
            store: "helloStore",
            method: "doInvoke",
            args: ["hello"],
        });
        var observer = jest.fn();
        newStore.onDidUpdate(observer);
        expect(storeDispatcher.handleDispatchDisposable).toHaveBeenLastCalledWith({
            store: "helloStore",
            method: "onDidUpdate",
        }, observer);
    });
});
