interface ListStorePathUnit {
    index?: string;
    name: string;
    type: "Map" | "List";
}
declare type StorePathUnit = ListStorePathUnit | string;
declare type StoreType = "Store" | "StoreList" | "StoreMap";
interface StoreShape {
    type: StoreType;
    filters: {
        [key: string]: StoreShape;
    } | null;
    path?: StorePathUnit[];
}
interface StoreFilters {
    [name: string]: StoreShape;
}
interface Stores {
    [storeKey: string]: any;
}
export default class StoreProxyHandler {
    storeProxyCache: Map<any, any>;
    genProxy(storePath: StorePathUnit[], forwardStore: Stores | null, forwarder: any): any;
    genIndexProxy(storePath: StorePathUnit[], childFilters: {
        [key: string]: StoreShape;
    }, forwarder: any): any;
    proxyStore(parentStore: StorePathUnit[], storeFilters: StoreFilters, forwarder: any): Stores | null;
    proxyStores(storeFilters: StoreFilters, forwarder: any): any;
}
export {};
//# sourceMappingURL=StoreProxyHandler.d.ts.map