"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var filterDifference_1 = __importDefault(require("../filterDifference"));
test("base diff", function () {
    var retObj = filterDifference_1.default({ "*": true, a: 1 }, { "*": false, b: 2 });
    expect(retObj).toEqual({
        updated: { "*": false, b: 2 },
        deleted: { a: true },
    });
    expect(filterDifference_1.default({}, { a: true, b: true })).toEqual({
        updated: { a: true, b: true },
        deleted: {},
    });
    expect(filterDifference_1.default({ "*": true, b: 1 }, { "*": false, b: 1 })).toEqual({
        updated: { "*": false },
        deleted: {},
    });
    expect(filterDifference_1.default({ "*": true, b: { c: "hello" }, f: "d" }, { "*": true, b: { c: "world" }, d: "mm" })).toEqual({
        updated: { b: { c: "world" }, d: "mm" },
        deleted: { f: true },
    });
    expect(filterDifference_1.default({ b: { c: "hello" }, f: "d" }, { b: { c: "world" }, d: "mm" })).toEqual({
        updated: { b: { c: "world" }, d: "mm" },
        deleted: { f: true },
    });
    expect(filterDifference_1.default({ b: { c: true }, f: "d" }, { b: { c: { m: true } }, d: "mm" })).toEqual({
        updated: { b: { c: { m: true } }, d: "mm" },
        deleted: { f: true },
    });
});
