"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var immutable_1 = require("immutable");
var objUtils_1 = require("./objUtils");
var isShallow = function (val) { return Array.isArray(val) || !objUtils_1.isObject(val) || immutable_1.List.isList(val); };
function objectMerge(origin, updated, deleted) {
    /**
     * origin is shallow
     * origin is not shallow, updated is shallow and deleted is empty(NO Update and No Delete)
     */
    if (isShallow(origin) || (isShallow(updated) && !objUtils_1.isObject(deleted))) {
        return updated;
    }
    if (immutable_1.Map.isMap(origin)) {
        var merged = void 0, deleteKeys_1 = [];
        // deleted = isObject(deleted) ? deleted : {};
        merged = origin.withMutations(function (map) {
            if (objUtils_1.isObject(deleted)) {
                Object.keys(deleted).forEach(function (key) {
                    if (deleted[key] === true) {
                        map.delete(JSON.parse(key));
                    }
                    else {
                        deleteKeys_1.push(key);
                    }
                });
            }
            var updateKeys = objUtils_1.isObject(updated) ? Object.keys(updated) : undefined;
            objUtils_1.union(updateKeys, deleteKeys_1).forEach(function (key) {
                var originKey = JSON.parse(key);
                map.set(originKey, objectMerge(origin.get(originKey), updated && updated[key], deleted && deleted[key]));
            });
        });
        return merged;
    }
    else {
        var merged_1;
        var deleteKeys = void 0;
        if (objUtils_1.isObject(deleted)) {
            merged_1 = {};
            Object.keys(origin).forEach(function (key) {
                if (deleted[key] !== true) {
                    merged_1[key] = origin[key];
                }
            });
            deleteKeys = Object.keys(deleted).filter(function (d) { return deleted[d] !== true; });
        }
        else {
            merged_1 = __assign({}, origin);
        }
        var updateKeys = objUtils_1.isObject(updated) ? Object.keys(updated) : undefined;
        objUtils_1.union(updateKeys, deleteKeys).forEach(function (key) {
            merged_1[key] = objectMerge(origin[key], updated && updated[key], deleted && deleted[key]);
        });
        return merged_1;
    }
}
exports.default = objectMerge;
